Attribute VB_Name = "bmpROU"
'---------------------------------------------------------------------------------------
' Module    : bmpROU
' Author    : (softKUS) - VII/2004
' Purpose   : routines for converting bitmaps to arrays and vice versa
'             by adapting bpp to the required value
'
' Hints     - You may use this code in your programs at your own risk
'           - You may not publish/sell it without the authour's agreement
'
'           - If you have suggestions for improvements or corrections,
'             please do not hesitate to email them to info@softkus.de
'---------------------------------------------------------------------------------------

Option Explicit


' ***
' Konstanten
' ***
Public Const S_OK               As Long = 0
Public Const BI_RGB             As Long = 0
Public Const DIB_RGB_COLORS     As Long = 0
Public Const dWord              As Long = 4
Public Const var_pvData         As Long = 8
Public Const sar_pvData         As Long = 12

Public Const IID_IPicture       As String = _
    "{7BF80980-BF32-101A-8BBB-00AA00300CAB}"


' ***
' Typen
' ***
' udt: Windows-Bitmap-Struktur
'      -> Einlesen der Bildinformationen
'         mit GDI_GetObject()
Public Type BITMAP
    bmType                      As Long
    bmWidth                     As Long
    bmHeight                    As Long
    bmWidthBytes                As Long
    bmPlanes                    As Integer
    bmBitsPixel                 As Integer
    bmBits                      As Long
End Type

' udt: Windows-Bitmap-Struktur
'      -> Erstellen von Bildern im Speicher,
'         mit GDI_CreateDibSection
'      -> Einlesen von Bilddaten (binr)
'         mit GDI_GetDiBits
'
'      wird nur als Unterstruktur von
'      BITMAPINFO bentigt (s.u.)
Public Type BITMAPINFOHEADER
    biSize                      As Long
    biWidth                     As Long
    biHeight                    As Long
    biPlanes                    As Integer
    biBitCount                  As Integer
    biCompression               As Long
    biSizeImage                 As Long
    biXPelsPerMeter             As Long
    biYPelsPerMeter             As Long
    biClrUsed                   As Long
    biClrImportant              As Long
End Type

' udt: Windows-Bitmap-Struktur
Public Type BITMAPINFO
    bmiHeader                   As BITMAPINFOHEADER
    bmiColors                   As Long
End Type

' udt: PictureDescription
'      -> Erstellen eines IPicture-Objektes
'         mit OleCreatePictureIndirect
Public Type PictDesc
    cbSizeofStruct              As Long
    picType                     As Long
    hImage                      As Long
    xExt                        As Long
    yExt                        As Long
End Type

' udt: VB-Array-Struktur
'      -> Setzen eines Bytearrays
'         gem vorhandener Daten
'         mit BMP2ARR
'
' !!!     Das Bytearray mu nach
'         Verwednung wieder auf
'         einen Nullpointer gesetzt
'         werden, sonst strzt VB ab
Public Type SAFEARRAY2D
    cDims                       As Integer
    fFeatures                   As Integer
    cbElements                  As Long
    cLocks                      As Long
    pvData                      As Long
    Dim1UBound                  As Long
    Dim1LBound                  As Long
    Dim2UBound                  As Long
    Dim2LBound                  As Long
End Type

' von asm-Routinen genutzte Struktur
' udt: AsmStruktur
'      -> fasst Infos ber Herkunftsdaten
'         und Zieldaten zusammen
'      dient vor allem dazu, die Anzahl
'      der Funktionsparamter zu begrenzen
Public Type asmBmpPara
    src                         As BITMAP
    tgt                         As BITMAP
    srcExpansion                As Long
End Type


' ***
' Externe Funktionen
' ***

' -----------------------------------------------------
' MIS
' -----------------------------------------------------
Public Declare Sub API_CopyByRef _
    Lib "kernel32" Alias "RtlMoveMemory" _
   (ByRef hpvDest As Any, _
    ByRef hpvSource As Any, _
    ByVal cbCopy As Long)

Public Declare Function VB6_ArrayPointer _
    Lib "msvbvm60" Alias "VarPtr" _
   (arr() As Any) As Long

Public Declare Function ASM_cdByRef _
    Lib "user32" Alias "CallWindowProcA" _
   (ByRef asm As Any, _
    ByRef PA1 As Any, _
    ByRef PA2 As Any, _
    ByRef PA3 As Any, _
    ByRef PA4 As Any) As Long

' -----------------------------------------------------
' GDI (graphical device interface)
' -----------------------------------------------------

' Handle auf Fenster-Gertekontext
Public Declare Function API_GetDC _
    Lib "user32" Alias "GetDC" _
   (ByVal hWnd As Long) As Long

' Freigeben eines Gertekontextes
Public Declare Function API_ReleaseDC _
    Lib "user32" Alias "ReleaseDC" _
   (ByVal hWnd As Long, _
    ByVal hDC As Long) As Long
        
' Einlesen von Informationen ber GDI-Objekte (z.B. Bilder)
Public Declare Function GDI_GetObject _
    Lib "gdi32" Alias "GetObjectA" _
   (ByVal hObject As Long, _
    ByVal nCount As Long, _
    ByRef lpObject As Any) As Long

' Einlesen binrer Bilddaten
Public Declare Function GDI_GetDIBits _
    Lib "gdi32" Alias "GetDIBits" _
   (ByVal hDC As Long, _
    ByVal hBM As Long, _
    ByVal uStartScan As Long, _
    ByVal cScanLines As Long, _
    ByVal lpvBits As Long, _
    ByRef lpbmi As BITMAPINFO, _
    ByVal uUsage As Long) As Long

' Erstellen eines gerte-unabhngigen Bildes
' (Device Independent Bitmap, DIB)
Public Declare Function GDI_CreateDIB _
    Lib "gdi32" Alias "CreateDIBSection" _
   (ByVal hDC As Long, _
    ByRef pbmi As BITMAPINFO, _
    ByVal iUsage As Long, _
    ByRef ppvBits As Long, _
    ByVal hSection As Long, _
    ByVal dwOffset As Long) As Long

' Lschen eines GDI-Objektes
Public Declare Function GDI_DeleteObject _
    Lib "gdi32" Alias "DeleteObject" _
   (ByVal hObject As Long) As Long


' -----------------------------------------------------
' OLE (Object Linked Embedding, heute: COM oder ActiveX genannt)
' -----------------------------------------------------

' Umwandeln eines CLSID-Strings in Binrcode
Public Declare Function OLE_CLSIDFromString _
    Lib "ole32" Alias "CLSIDFromString" _
   (ByVal lpszProgID As Long, _
    ByRef pCLSID As Any) As Long

' Erstellen eines IPicture-Objektes aus einem GDI-Bitmap-Handle
Public Declare Function OLE_CreatePic _
    Lib "olepro32" Alias "OleCreatePictureIndirect" _
   (ByRef lpPictDesc As PictDesc, _
    ByRef riid As Any, _
    ByVal fPictureOwnsHandle As Long, _
    ByRef ipic As IPicture) As Long

' ARR2BMP       Convert array to bitmap
'
' CALL:         ARR2BMP(arr, bmi, @hMB)
'
' IN:           udt:bmi BitmapInfo structure
'               var:arr Array to be converted
'               lng:hBM Placeholder for bitmap handle
'
' OUT:          bol     success
'
Function ARR2BMP( _
    arr, _
    bmi As BITMAPINFO, _
    hBM As Long) As Boolean

    ' info zum Erstellen eines neuen Pictures
    Dim dsc         As PictDesc
    
    ' temporr benutzter Gertekontext
    Dim hDC         As Long
    
    ' Zeiger auf die binren Bildpuffer
    Dim ptr         As Long
    
    ' Zeiger auf den Arraypuffer
    Dim adr         As Long
    
    ' Init (array pointer ermitteln)
    hBM = 0
    arrINF arr, adr
    
    If adr Then hDC = API_GetDC(0)
    If hDC Then hBM = GDI_CreateDIB(hDC, bmi, DIB_RGB_COLORS, ptr, 0, 0)
    
    ' ungltiges Array
    If adr = 0 Then
    
    ' Gertekontext konnte nicht ermitelt werden
    ElseIf hDC = 0 Then
    
    ' Bildkopie konnte nicht erstellt werden
    ElseIf hBM = 0 Or ptr = 0 Then
        If hBM Then GDI_DeleteObject hBM
        
    Else
        API_CopyByRef ByVal ptr, ByVal adr, bmi.bmiHeader.biSizeImage
        ARR2BMP = True
    End If
        
    If hDC Then API_ReleaseDC 0, hDC
End Function

' ARR2PIC       Convert array to StdPicture
'
' CALL:         ARR2PIC(arr, bmi, @tgt)
'
' IN:           var:arr Array to be converted
'               udt:bmi BitmapInfo structure
'               pic:tgt Standardpicture object to be set
'
' OUT:          bol     success
'
Function ARR2PIC( _
    arr, _
    bmi As BITMAPINFO, _
    tgt As StdPicture) As Boolean

    Dim hBM As Long
    
    If ARR2BMP(arr, bmi, hBM) Then ARR2PIC = BMP2PIC(hBM, tgt, True)
End Function

' arrINF        Get array information
'
' CALL:         arrINF(arr, [@adr:lpData])
'
' IN:           var:arr Array
'               lng:adr Placeholder for data-pointer
'
' OUT:          lng     Pointer to array structure

Function arrINF( _
    arr As Variant, _
    Optional lpData As Long) As Long
    
    Dim ptr    As Long
    
    If IsArray(arr) Then
        API_CopyByRef ptr, ByVal VarPtr(arr) + var_pvData, dWord
        If ptr Then API_CopyByRef ptr, ByVal ptr, dWord
        If ptr Then API_CopyByRef lpData, ByVal ptr + sar_pvData, dWord
    
        arrINF = ptr
    End If
End Function

' BMP2ARR       Convert bitmap to array
'
' CALL:         BMP2ARR(hBM, @bmi, @sar, @arr, [bpp], [cnt:dims])
'
' IN:           lng:hBM Bitmap handle
'               var:arr Array to be filled (byte v integer v long)
'               udt:bmi Bitmapinfo (to be filled with hBM-Info)
'               udt:sar Savearray structure
'               lng:bpp BitsPerPixel (dflt=24)
'               lng:cnt Number of dimensions (dflt=2)
'
' OUT:          bol     success
'
' Caution:      If hBM matches the required color format and its
'               data-pointer can be get, then sar is set acc.,
'               arr points directly to the originally data. This
'               link has to be deleted before VB destroys arr!
'               If hBM does not match the requirements, arr is
'               set physically. sar.pvData equals to 0 and no
'               further action has to be taken, because arr will
'               be automatically destroyed correctly by VB.
'
Function BMP2ARR( _
    hBM As Long, _
    arr, _
    bmi As BITMAPINFO, _
    sar As SAFEARRAY2D, _
    Optional bpp As Long = 24, _
    Optional dims As Long = 2, _
    Optional X1 As Long = 0, _
    Optional Y1 As Long = 0, _
    Optional XN As Long = -1, _
    Optional YN As Long = -1) As Boolean
    
    Dim bmp   As BITMAP
    Dim dmy   As SAFEARRAY2D
    Dim hDC   As Long
    Dim fct   As Long
    Dim ptr   As Long
    Dim tmp   As Long
    Dim flg   As Boolean
    
    On Error Resume Next
    
    Select Case VarType(arr)
    Case vbArray Or vbByte:    fct = 1
    Case vbArray Or vbInteger: fct = 2
    Case vbArray Or vbLong:    fct = 4
    End Select
    
    If fct = 0 Then
        MsgBox "Ungltiger Arraytyp"
        
    ElseIf GDI_GetObject(hBM, Len(bmp), bmp) = 0 Then
        MsgBox "Bildinformationen konnten nicht gelesen werden"
        
    Else
        flg = ((X1 Or XN) = 0) And ((Y1 And YN) = -1)
        tmp = (bpp / 8# * bmp.bmWidth + 3) And -4&
        
        ' bmi to be re-used later (ARR2PIC)
        With bmi.bmiHeader
            .biSize = Len(bmi.bmiHeader)
            .biCompression = BI_RGB
            .biPlanes = 1
            .biBitCount = bpp
            .biHeight = bmp.bmHeight
            .biWidth = bmp.bmWidth
            .biSizeImage = tmp * .biHeight
    
               ' If the picture's color format matches the
               ' requirement and no range is specified,
               ' fill savearray-structure
            If bmp.bmBits <> 0 _
               And bmp.bmBitsPixel = bpp _
               And flg = True Then
                
                With sar
                    .cbElements = 1
                    .pvData = bmp.bmBits
                    .cDims = dims
                    
                    If dims = 1 Then
                        .Dim1UBound = bmi.bmiHeader.biSizeImage / fct
                        .Dim2UBound = 0
                    Else
                        .Dim1UBound = bmp.bmHeight
                        .Dim2UBound = tmp / fct
                    End If
                End With
                
                Erase arr
                API_CopyByRef ptr, ByVal VarPtr(arr) + var_pvData, dWord
                API_CopyByRef ByVal ptr, VarPtr(sar), dWord
                BMP2ARR = True
                    
            Else
                ' otherwise, convert it via GetDIBits
                ' and copy its data to a bytearray
                If dims = 1 Then
                    ReDim arr(.biSizeImage / fct - 1)
                    arrINF arr, ptr
                Else
                    ReDim arr(tmp / fct - 1, .biHeight - 1)
                    arrINF arr, ptr
                End If
                
                sar = dmy
                hDC = API_GetDC(0)
    
                If hDC = 0 Then
                    MsgBox "Gertekontext konnte nicht erzeugt werden"
            
                ElseIf GDI_GetDIBits(hDC, hBM, 0, .biHeight, ptr, _
                    bmi, DIB_RGB_COLORS) = 0 Then
                    
                    MsgBox "Bilddaten konnten nicht gelesen werden"
            
                ElseIf flg Then
                    BMP2ARR = True
                
                ElseIf bmpPart(bmi.bmiHeader, ptr, ptr, X1, XN, Y1, YN) Then
                    BMP2ARR = True
                
                    If dims = 1 Then
                        ReDim Preserve arr(.biSizeImage / fct - 1)
                    Else
                        tmp = (bpp / 8# * .biWidth + 3) And -4&
                        ptr = arrINF(arr)
                        API_CopyByRef ByVal ptr + 16, .biHeight, 4
                        API_CopyByRef ByVal ptr + 24, CLng(tmp / fct), 4
                    End If
                End If
            
                If hDC Then API_ReleaseDC 0, hDC
            End If
        End With
    End If
End Function

' BMP2PIC       Convert bitmap to StandardPicture
'
' CALL:         BMP2PIC(hBM, @tgt, [F1:tgtOwnsBmp],
'                       [F2:delBmpOnErr], [F3:srcMode])
'
' IN:           lng:hBM Bitmap handle
'               obj:tgt StandardPicture object to be set
'               bol:F1  .T.: tgt owns the handle (dflt)
'                       .F.: tgt does not own the handle
'               bol:F2  .T.: delete hBM, if an err occurs (dflt)
'                       .F.: do not delete hBM on error
'               enm:F3  hBM type (dflt=bitmap)
'
' OUT:          bol     success
'
Function BMP2PIC( _
    hBM As Long, _
    tgt As StdPicture, _
    Optional tgtOwnsBmp As Boolean = True, _
    Optional delBmpOnErr As Boolean = False, _
    Optional srcMode As PictureTypeConstants = vbPicTypeBitmap) As Boolean

    ' Neues Picture-Objekt
    Dim pic         As IPicture
    
    ' info zum Erstellen eines neuen Pictures
    Dim dsc         As PictDesc
    
    ' clsid des IPicture-Objektes
    Dim iid(15)     As Byte
    
    dsc.cbSizeofStruct = Len(dsc)
    dsc.picType = srcMode
    dsc.hImage = hBM
    
    If OLE_CLSIDFromString(StrPtr(IID_IPicture), iid(0)) <> S_OK Then
        MsgBox "OLE Fehler"
                
    ElseIf OLE_CreatePic(dsc, iid(0), tgtOwnsBmp, pic) <> S_OK Then
        MsgBox "OLE picture creation error"
    
    Else
        Set tgt = Nothing
        Set tgt = pic
        BMP2PIC = True
    End If
        
    If (BMP2PIC = False) And delBmpOnErr Then GDI_DeleteObject hBM
End Function

Function bmpPart( _
    bmh As BITMAPINFOHEADER, _
    src As Long, _
    tgt As Long, _
    X1 As Long, _
    XN As Long, _
    Y1 As Long, _
    YN As Long) As Boolean

    Static asm(35) As Long

    If asm(0) = 0 Then
        asm(0) = &HEC8B5590:  asm(1) = &H8B575653:  asm(2) = &H3B8B0C5D
        asm(3) = &H8B044B8B:  asm(4) = &H538B0843:  asm(5) = &H85D8B0C
        asm(6) = &HB0C738B:   asm(7) = &H8B037FD2:  asm(8) = &HC00B0853
        asm(9) = &HAF0F607C:  asm(10) = &H2BC203F0: asm(11) = &H4760843
        asm(12) = &H5276D02B: asm(13) = &H37FC90B:  asm(14) = &H8B044B8B
        asm(15) = &H7CC00BC7: asm(16) = &H7BB70F45: asm(17) = &H3EFC112
        asm(18) = &HC7AF0F50: asm(19) = &H7303F003: asm(20) = &HC1035814
        asm(21) = &H7604432B: asm(22) = &H76C82B04: asm(23) = &H1C4B8929
        asm(24) = &HF205389:  asm(25) = &HC183CFAF: asm(26) = &HFCE18003
        asm(27) = &H8B244B89: asm(28) = &HC12B0C43: asm(29) = &HC12C7B8B
        asm(30) = &HF35102E9: asm(31) = &HF00359A5: asm(32) = &HF9F7754A
        asm(33) = &H1BF801EB: asm(34) = &H5B5E5FC0: asm(35) = &H10C25D
    End If

    ' -----------------------------------------------------------------
    
    Dim abp     As asmBmpPara
    Dim lng(3)  As Long
    
    With abp.src
        .bmBits = src
        .bmBitsPixel = bmh.biBitCount
        .bmHeight = bmh.biHeight
        .bmWidth = bmh.biWidth
        .bmPlanes = bmh.biPlanes
        .bmWidthBytes = ((.bmBitsPixel \ 8) * .bmWidth + 3) And -4&
    End With
    
    abp.tgt = abp.src
    abp.tgt.bmBits = tgt
    
    lng(0) = X1
    lng(1) = XN
    lng(2) = Y1
    lng(3) = YN
    
    If ASM_cdByRef(asm(0), abp, lng(0), 0&, 0&) Then
        With abp.tgt
            bmh.biWidth = .bmWidth
            bmh.biHeight = .bmHeight
            
            bmh.biSizeImage = (((.bmBitsPixel \ 8) * .bmWidth + 3) _
                And -4&) * .bmHeight
                
            bmpPart = True
        End With
    End If
End Function

