Attribute VB_Name = "bmpRotate"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

'---------------------------------------------------------------------------------------
' Module    : bmpRotate
' Author    : (softKUS) - VII/2004
' Purpose   : rotates bitmaps with several options like antiA
'
' Hints     - You may use this code in your programs at your own risk
'           - You may not publish/sell it without the authour's agreement
'
'           - If you have suggestions for improvements or corrections,
'             please do not hesitate to email them to info@softkus.de
'---------------------------------------------------------------------------------------

Option Explicit

' asmRotate     Rotieren einer Bitmap
'
' AUFRUF:       asmRotate(src, tgt, [Angle], [fctX], [fctY],
'                              [cut], [Adjust], [AntiA], [dfltAA],
'                              [useMsk], [mskCol], [AutoMsk], [FillMsk])
'
' EIN:          pic:src     Standardpicture mit gltigem Bild
'               pic:tgt     Standardpicture
'               dbl:Angle   Winkel in 10tel Grad (Vorgabe = 90)
'               dbl:fctX    Grenfaktor Breite (Vorgabe = 1 = 100%)
'               dbl:fctY    Grenfaktor Hhe (Vorgabe = 1 = 100 %)
'               bol:cut     Bild abschneiden (Vorgabe = False)
'               bol:Adjust  Bild an die neuen Dimensionen anpassen (Vorgabe = True)
'               bol:AntiA   Bild gltten (Vorgabe = True)
'               dbl:dlftAA  AntiA-Faktor, wenn Angle mod 90 = 0 (Vorgabe = 0)
'               bol:UseMsk  Eine Farbe maskieren (Vorgabe = False)
'               lng:MskCol  Vorgabe = 0
'               bol:AutoMsk 1. Bildpunkt = Maskierfarbe (Vorgabe = True)
'               lng:FilMsk  Flle ungenutze Bereicht mit MskCol (Vorgabe = False)
'
' AUS:          bol         Erfolg
'
Function asmRotate( _
    src As StdPicture, _
    tgt As StdPicture, _
    Optional Angle As Double = 90, _
    Optional fctX As Double = 1, _
    Optional fctY As Double = 1, _
    Optional cut As Boolean = False, _
    Optional Adjust As Boolean = True, _
    Optional AntiA As Boolean = True, _
    Optional dfltAA As Double = 0, _
    Optional UseMsk As Boolean = False, _
    Optional MskCol As Long = 0, _
    Optional AutoMsk As Boolean = True, _
    Optional FillMsk As Boolean = False, _
    Optional X1 As Long, _
    Optional XN As Long = -1, _
    Optional Y1 As Long, _
    Optional YN As Long = -1) As Boolean
        
    Static asm(181) As Long

    If asm(0) = 0 Then
        asm(0) = &HEC8B5590:  asm(1) = &H8B575653:  asm(2) = &H738B085D
        asm(3) = &H2C7B8B14:  asm(4) = &H3320538B:  asm(5) = &H504850C0
        asm(6) = &HF710458B:  asm(7) = &H41445:     asm(8) = &H1740000
        asm(9) = &HC1C80FAD:  asm(10) = &H575008E8: asm(11) = &H80144D8B
        asm(12) = &HE18312F1: asm(13) = &HC1F6511F: asm(14) = &H8B087408
        asm(15) = &HAF0F1C4B: asm(16) = &H83ABF3CA: asm(17) = &HF48B5CEC
        asm(18) = &H507ED99B: asm(19) = &H80D4458B: asm(20) = &H89660CCC
        asm(21) = &H6ED95246: asm(22) = &HC458B52:  asm(23) = &H40DDEED9
        asm(24) = &H3840DD48: asm(25) = &H524040DD: asm(26) = &H5EDDC1D9
        asm(27) = &H3056DD38: asm(28) = &H511C4B8B: asm(29) = &HC2D9E8D9
        asm(30) = &HDA5856DB: asm(31) = &HE1D95866: asm(32) = &HDF9BD5D8
        asm(33) = &H759E9BE0: asm(34) = &HDDC4D802: asm(35) = &H66DC205E
        asm(36) = &H285EDD20: asm(37) = &HC1D9E8D9: asm(38) = &HDA5456DB
        asm(39) = &HE1D95466: asm(40) = &HDF9BD5D8: asm(41) = &H759E9BE0
        asm(42) = &HDDC4D802: asm(43) = &H66DC105E: asm(44) = &H185EDD10
        asm(45) = &H3B584E8B: asm(46) = &H8D0F044B: asm(47) = &H14C
        asm(48) = &H3B547E8B: asm(49) = &H8D0F087B: asm(50) = &H140
        asm(51) = &H11445F7:  asm(52) = &HF000000:  asm(53) = &HF284&
        asm(54) = &H99C03300: asm(55) = &HFCA3B4A:  asm(56) = &H1278C
        asm(57) = &HFFA3B00:  asm(58) = &H11F8C:    asm(59) = &H78C90B00
        asm(60) = &H41010C02: asm(61) = &H7D044B3B: asm(62) = &HB020C02
        asm(63) = &HC0278FF:  asm(64) = &H7B3B4704: asm(65) = &HC027D08
        asm(66) = &HF4F4908:  asm(67) = &H30C7BAF:  asm(68) = &H3C8D147B
        asm(69) = &HE8538F:   asm(70) = &H5B000000: asm(71) = &H134C381
        asm(72) = &H5BD70000: asm(73) = &HA8E44D8B: asm(74) = &HE8077401
        asm(75) = &H12F:      asm(76) = &H118B0275: asm(77) = &HC7831689
        asm(78) = &H7402A804: asm(79) = &H11DE807:  asm(80) = &H2750000
        asm(81) = &H5689118B: asm(82) = &HC7B0304:  asm(83) = &H77408A8
        asm(84) = &H10AE8:    asm(85) = &H8B027500: asm(86) = &HC568911
        asm(87) = &HA804EF83: asm(88) = &HE8077404: asm(89) = &HF7
        asm(90) = &H118B0275: asm(91) = &HB9085689: asm(92) = &H2
        asm(93) = &HE2C1D58A: asm(94) = &H8AC03308: asm(95) = &HDB503104
        asm(96) = &H4EDC2404: asm(97) = &H184EDC28: asm(98) = &H31448A58
        asm(99) = &H4DB5004:  asm(100) = &H204EDC24: asm(101) = &HDE184EDC
        asm(102) = &H448A58C1: asm(103) = &HDB500831: asm(104) = &H4EDC2404
        asm(105) = &H104EDC28: asm(106) = &H8A58C1DE: asm(107) = &H500C3144
        asm(108) = &HDC2404DB: asm(109) = &H4EDC204E: asm(110) = &HDBC1DE10
        asm(111) = &H8A58241C: asm(112) = &HB27949D0: asm(113) = &H9EE8&
        asm(114) = &HB17EB00: asm(115) = &HB3D78C9: asm(116) = &HF3978FF
        asm(117) = &H30C7BAF: asm(118) = &H3C8D147B: asm(119) = &H7DE88F
        asm(120) = &H28740000: asm(121) = &H89E47D8B: asm(122) = &H1445F717
        asm(123) = &H10:      asm(124) = &H4D831A74: asm(125) = &H438B20E0
        asm(126) = &H24042B1C: asm(127) = &H73EC453B: asm(128) = &HEC458903
        asm(129) = &H73F04539: asm(130) = &HF0458903: asm(131) = &H4E44583
        asm(132) = &HDD0C458B: asm(133) = &HC2DE1840: asm(134) = &HDE3040DD
        asm(135) = &HF4959C1: asm(136) = &HFFFE4E85: asm(137) = &H545EDBFF
        asm(138) = &HF7585EDB: asm(139) = &H30E045: asm(140) = &H6750000
        asm(141) = &H2924538B: asm(142) = &H4A5AE455: asm(143) = &H46DD3674
        asm(144) = &H2860DC38: asm(145) = &HDC3046DD: asm(146) = &H18E92040
        asm(147) = &HFFFFFE:  asm(148) = &H0:       asm(149) = &H30201
        asm(150) = &HC0804:   asm(151) = &H8B0F0A05: asm(152) = &H8E2C117
        asm(153) = &HF708EAC1: asm(154) = &H2E045:  asm(155) = &H3750000
        asm(156) = &HC3E8553B: asm(157) = &HDD305EDD: asm(158) = &H6ED9385E
        asm(159) = &H1445F750: asm(160) = &H10:     asm(161) = &H458B4274
        asm(162) = &H2C432BE4: asm(163) = &H2473F799: asm(164) = &H2B204387
        asm(165) = &H43292043: asm(166) = &HEC758B20: asm(167) = &H2BF0458B
        asm(168) = &H438740C6: asm(169) = &H1C432B1C: asm(170) = &HE0C11E74
        asm(171) = &H24432902: asm(172) = &H8D2C7B8B: asm(173) = &H4B8BB734
        asm(174) = &H2E9C124: asm(175) = &H5120538B: asm(176) = &H359A5F3
        asm(177) = &HF7754AF0: asm(178) = &HF4658DF9: asm(179) = &H5E5FC01B
        asm(180) = &H10C25D5B: asm(181) = &H0
    End If
    
    ' **************************************************************************
        
    Dim sar         As SAFEARRAY2D
    Dim bmi         As BITMAPINFO
    Dim abp         As asmBmpPara
    Dim dbl(10)     As Double
    Dim flg         As Long
    Dim src_buf()   As Long
    Dim tgt_buf()   As Long
        
    Const xPI       As Double = 3.14159265358979 / 180
        
        ' Einlesen der Bildinformationen
    If Angle < 0 Or Angle > 360 Then
    ElseIf BMP2ARR(src.Handle, src_buf, bmi, sar, 32, 1, X1, Y1, XN, YN) Then
        
        ' Setzen der abp-Struktur (source)
        With abp.src
            .bmBits = VarPtr(src_buf(0))
            .bmBitsPixel = 32
            .bmHeight = bmi.bmiHeader.biHeight
            .bmWidth = bmi.bmiHeader.biWidth
            .bmPlanes = 1
            .bmWidthBytes = .bmWidth * 4
        End With
        
        ' Setzen der abp-Struktur (target)
        abp.tgt = abp.src
        
        With abp.tgt
            .bmWidth = .bmWidth * fctX
            .bmHeight = .bmHeight * fctY
            
            If cut = False Or Adjust = True Then
                .bmWidth = .bmWidth * .bmWidth
                .bmHeight = .bmHeight * .bmHeight
                .bmWidth = Sqr(.bmWidth + .bmHeight)
                .bmHeight = .bmWidth
            End If
            
            ReDim tgt_buf(.bmWidth * .bmHeight - 1)
            .bmBits = VarPtr(tgt_buf(0))
            .bmWidthBytes = .bmWidth * 4
        
            ' Berechnen der Faktoren
            dbl(0) = Angle
            dbl(1) = Cos(Angle * xPI)
            dbl(2) = Sin(Angle * xPI)
            dbl(3) = dbl(1) / fctX
            dbl(4) = dbl(1) / fctY
            dbl(5) = dbl(2) / fctX
            dbl(6) = dbl(2) / fctY
            dbl(7) = (abp.src.bmWidth + (dbl(2) - dbl(1)) * .bmWidth / fctX) / 2
            dbl(8) = (abp.src.bmHeight - (dbl(2) + dbl(1)) * .bmHeight / fctY) / 2
            dbl(9) = dfltAA
        End With
        
        ' Aufruf der ASM-Funktion
        flg = (AntiA And 1) _
           Or (UseMsk And 2) _
           Or (AutoMsk And 4) _
           Or (FillMsk And 8) _
           Or (Adjust And 16)
        
        ASM_cdByRef asm(0), abp, dbl(0), ByVal MskCol, ByVal flg
        
        ' Erstellen/Zurckgeben eines neuen Bildes
        With bmi.bmiHeader
            .biHeight = abp.tgt.bmHeight
            .biWidth = abp.tgt.bmWidth
            .biSizeImage = .biWidth * .biHeight * 4
            
            asmRotate = ARR2PIC(tgt_buf, bmi, tgt)
        End With
        
        ' Wenn die Original-Bilddaten verwendet wurden,
        ' (sar-pvData gesetzt), arr auf Nullpointer setzen
        If sar.pvData Then
            API_CopyByRef ByVal VB6_ArrayPointer(src_buf), 0&, dWord
        End If
    End If
End Function

' basRotate     Rotieren einer Bitmap
'
' AUFRUF:       basRotate(src, tgt, [Angle], [fctX], [fctY],
'                              [cut], [Adjust], [AntiA], [dfltAA],
'                              [useMsk], [mskCol], [AutoMsk], [FillMsk])
'
' EIN:          pic:src     Standardpicture mit gltigem Bild
'               pic:tgt     Standardpicture
'               dbl:Angle   Winkel in 10tel Grad (Vorgabe = 90)
'               dbl:fctX    Grenfaktor Breite (Vorgabe = 1 = 100%)
'               dbl:fctY    Grenfaktor Hhe (Vorgabe = 1 = 100 %)
'               bol:cut     Bild abschneiden (Vorgabe = False)
'               bol:Adjust  Bild an die neuen Dimensionen anpassen
'                           (Vorgabe = True)
'               bol:AntiA   Bild gltten (Vorgabe = True)
'               dbl:dlftAA  AntiA-Faktor, wenn Angle mod 90 = 0
'                           (Vorgabe = 0)
'               bol:UseMsk  Eine Farbe maskieren (Vorgabe = False)
'               lng:MskCol  Vorgabe = 0
'               bol:AutoMsk 1. Bildpunkt = Maskierfarbe
'                           (Vorgabe = True)
'               lng:FilMsk  Flle ungenutze Bereicht mit MskCol
'                           (Vorgabe = False)
'
' AUS:          bol         Erfolg
'
Function basRotate( _
    src As StdPicture, _
    tgt As StdPicture, _
    Optional Angle As Double = 90, _
    Optional fctX As Double = 1, _
    Optional fctY As Double = 1, _
    Optional cut As Boolean = False, _
    Optional Adjust As Boolean = True, _
    Optional AntiA As Boolean = True, _
    Optional dfltAA As Double = 0, _
    Optional UseMsk As Boolean = False, _
    Optional MskCol As Long = 0, _
    Optional AutoMsk As Boolean = True, _
    Optional FillMsk As Boolean = False, _
    Optional X1 As Long, _
    Optional XN As Long = -1, _
    Optional Y1 As Long, _
    Optional YN As Long = -1) As Boolean
    
    Dim src_sar     As SAFEARRAY2D
    Dim src_bmi     As BITMAPINFO
    Dim tgt_bmi     As BITMAPINFO
    Dim rmd(3)      As Double
    Dim acos        As Double
    Dim asin        As Double
    Dim actX        As Double
    Dim actY        As Double
    Dim svdX        As Double
    Dim svdY        As Double
    Dim intX        As Long
    Dim intY        As Long
    Dim tmpX        As Long
    Dim tmpY        As Long
    Dim tmpC        As Long
    Dim tgtW        As Long
    Dim tgtH        As Long
    Dim row         As Long
    Dim col         As Long
    Dim pnt         As Long
    Dim vld         As Long
    Dim I1          As Long
    Dim src_buf()   As Byte
    Dim tgt_buf()   As Byte
    Dim act(2, 3)   As Byte
    
    Dim col1 As Long
    Dim row1 As Long
    Dim col2 As Long
    Dim row2 As Long
    
    Const xPI   As Double = 3.14159265358979 / 180
    
    If Angle < 0 Or Angle > 360 Then
    
    ElseIf BMP2ARR(src.Handle, src_buf, src_bmi, src_sar, 24, 2, X1, _
        Y1, XN, YN) Then
        
        tgt_bmi = src_bmi
        
        ' Berechnen von Zielbreite und -hhe
        With src_bmi.bmiHeader
            tgtW = .biWidth * fctX
            tgtH = .biHeight * fctY
            
            If cut = False Or Adjust = True Then
                tgtW = Sqr(tgtW * tgtW + tgtH * tgtH)
                tgtH = tgtW
            End If
            
            With tgt_bmi.bmiHeader
                .biWidth = tgtW
                .biHeight = tgtH
                .biSizeImage = ((tgtW * 3 + 3) And -4&) * tgtH
            End With
            
            ' Zielarray dimensionieren
            ReDim tgt_buf(((tgtW * 3 + 3) And -4&) - 1, tgtH - 1)
            
            
            ' Faktoren berechnen
            acos = Cos(Angle * xPI)
            asin = Sin(Angle * xPI)
    
            actX = (.biWidth + (asin - acos) * tgtW / fctX) / 2
            actY = (.biHeight - (asin + acos) * tgtH / fctY) / 2
            col1 = &H7FFFFFFF
            row1 = col1
            
            If AutoMsk Then API_CopyByRef MskCol, src_buf(0, 0), 3
            
            MskCol = (MskCol And 255) * &H10000 + _
                (MskCol And &HFF00&) + (MskCol \ &H10000)
            
            ' ggf. Bild mit Maskfarbe fllen
            If FillMsk Then
                For row = 0 To tgtH - 1
                    For col = 0 To tgtW - 1
                        API_CopyByRef tgt_buf(col * 3, row), MskCol, 3
                    Next
                Next
            End If
                
            ' row-loop
            For row = 0 To tgtH - 1
                svdX = actX
                svdY = actY
                
                ' column-loop
                For col = 0 To tgtW - 1
                    intX = Fix(actX)
                    intY = Fix(actY)
                    
                    ' Punkt validieren
                    vld = ((intX >= 0 And intX < .biWidth) And 1) _
                        + ((intX > -2 And intX + 1 < .biWidth) And 2) _
                        + ((intY >= 0 And intY < .biHeight) And 4) _
                        + ((intY > -2 And intY + 1 < .biHeight) And 8)
                    
                    vld = Choose(vld + 1, 0, 0, 0, 0, 0, 1, 2, _
                                       3, 0, 4, 8, 12, 0, 5, 10, 15)
                        
                    If vld = 0 Then     ' ungltiger Punkt
                    ElseIf AntiA Then   ' Farb-Mittelwerte berechnen
                        tmpX = intX
                        tmpY = intY
                        tmpC = 0
                        pnt = 0
                        
                        For I1 = 0 To 3
                            API_CopyByRef act(0, I1), tgt_buf(col * 3, row), 3
                            
                            If (vld And 1) Then
                                API_CopyByRef tmpC, src_buf(tmpX * 3, tmpY), 3
                                
                                If UseMsk = False Or tmpC <> MskCol Then
                                    API_CopyByRef act(0, I1), tmpC, 3
                                End If
                            End If
                            
                            tmpX = tmpX + 1
                            If I1 = 1 Then tmpX = tmpX - 2: tmpY = tmpY + 1
                            vld = Fix(vld / 2)
                        Next
                        
                        rmd(1) = Abs(actX - intX)
                        rmd(3) = Abs(actY - intY)
                        
                        If rmd(1) = 0 Then
                            rmd(1) = dfltAA
                        End If
                        If rmd(3) = 0 Then rmd(3) = dfltAA
                        rmd(0) = 1 - rmd(1)
                        rmd(2) = 1 - rmd(3)
                        
                        For I1 = 2 To 0 Step -1
                            pnt = pnt * 256 _
                                + ((act(I1, 0) * rmd(0) * rmd(2) _
                                + act(I1, 1) * rmd(1) * rmd(2) _
                                + act(I1, 2) * rmd(0) * rmd(3) _
                                + act(I1, 3) * rmd(1) * rmd(3)) And 255)
                        Next
                        
                        vld = 1
                        
                    ElseIf (vld And 5) = 5 Then
                        API_CopyByRef pnt, src_buf(intX * 3, intY), 3
                    End If
                        
                    ' Punkt bergehen
                    If vld = 0 Then
                    ElseIf pnt <> MskCol Or UseMsk = False Then
                        ' Minima/Maxima festhalten
                        If col1 > col Then col1 = col
                        If row1 > row Then row1 = row
                        If col2 < col Then col2 = col
                        If row2 < row Then row2 = row
                        
                        ' Farbwert in Zielpuffer kopieren
                        API_CopyByRef tgt_buf(col * 3, row), pnt, 3
                    End If
                
                    actX = actX + acos / fctX
                    actY = actY + asin / fctY
                Next
            
                actX = svdX - asin / fctX
                actY = svdY + acos / fctY
            Next
        End With
        
        ' ggf. Bild gem Minima/Maxima verschieben
        If Adjust = True Then
            With tgt_bmi.bmiHeader
                .biWidth = col2 - col1 + 1
                .biHeight = row2 - row1 + 1
                tgtW = (.biWidth * 3 + 3) And -4&
                .biSizeImage = tgtW * .biHeight
            End With
            
            If col1 > 0 Or row1 > 0 Then
                pnt = VarPtr(tgt_buf(0, 0))
                
                For row = row1 To row2
                    API_CopyByRef ByVal pnt, tgt_buf(col1 * 3, row), tgtW
                    pnt = pnt + tgtW
                Next
            End If
        End If
        
        ' neues Bitmap erstellen und auf tgt-Picture setzen
        basRotate = ARR2PIC(tgt_buf, tgt_bmi, tgt)
        
        If src_sar.pvData Then
            API_CopyByRef ByVal VB6_ArrayPointer(src_buf), 0&, dWord
        End If
    End If
End Function

